// src/backend/dynamic_sub_request.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "dynamic_sub_request.hh"

#include "smartp.tcc"

#include <cassert>

using namespace sgpem;

DynamicSubRequest::DynamicSubRequest(StaticSubRequest* core, 
                                     DynamicResource* resource) :
  _static_subrequest(core), _dynamic_resource(resource), 
  _queue_position(-1)  				    
{
  assert(core != NULL);
  assert(resource != NULL);
}

DynamicResource& 
DynamicSubRequest::get_resource()
{
  return *_dynamic_resource;
}

unsigned int 
DynamicSubRequest::get_places() const
{
  return _static_subrequest->get_places();
}

unsigned int 
DynamicSubRequest::get_length() const
{
  return _static_subrequest->get_length();
}

int 
DynamicSubRequest::get_queue_position() const
{
  return _queue_position;
}

void 
DynamicSubRequest::set_queue_position(int position)
{
  _queue_position = position;
}

void 
DynamicSubRequest::serialize(SerializeVisitor& translator) const
{
  //blah blah blah TODO
}

